// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/ActionIdList.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/action_id_list.h"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ACTION_ID_LIST__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ACTION_ID_LIST__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'MIN_SIZE'.
enum
{
  etsi_its_denm_ts_msgs__msg__ActionIdList__MIN_SIZE = 1
};

/// Constant 'MAX_SIZE'.
enum
{
  etsi_its_denm_ts_msgs__msg__ActionIdList__MAX_SIZE = 8
};

// Include directives for member types
// Member 'array'
#include "etsi_its_denm_ts_msgs/msg/detail/action_id__struct.h"

/// Struct defined in msg/ActionIdList in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__ActionIdList
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF shall contain a list of @ref ActionId.
  ///
  ///  * @category: Communication Information
  ///  * @revision: Created in V2.1.1 based on ReferenceDenms from DENM Release 1
  /// */
  /// ActionIdList::= SEQUENCE (SIZE(1..8, ...)) OF ActionId
  /// ------------------------------------------------------------------------------
  etsi_its_denm_ts_msgs__msg__ActionId__Sequence array;
} etsi_its_denm_ts_msgs__msg__ActionIdList;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__ActionIdList.
typedef struct etsi_its_denm_ts_msgs__msg__ActionIdList__Sequence
{
  etsi_its_denm_ts_msgs__msg__ActionIdList * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__ActionIdList__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ACTION_ID_LIST__STRUCT_H_
