// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/DeltaAltitude.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/delta_altitude__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__DeltaAltitude__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x7f, 0xd0, 0xa4, 0x58, 0x70, 0xaa, 0x4c, 0xf4,
      0x1e, 0x16, 0xeb, 0xd6, 0xb6, 0xa0, 0xa8, 0x96,
      0xbb, 0xb7, 0x7a, 0xfb, 0xd0, 0x14, 0x00, 0xd4,
      0xb2, 0x86, 0xd0, 0xec, 0x77, 0x0c, 0x12, 0xa5,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__DeltaAltitude__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/DeltaAltitude";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__DeltaAltitude__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__DeltaAltitude__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__DeltaAltitude__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__DeltaAltitude__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__DeltaAltitude__TYPE_NAME, 39, 39},
      {etsi_its_denm_ts_msgs__msg__DeltaAltitude__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents an offset altitude with regards to a defined altitude value.\n"
  "#  * It may be used to describe a geographical point with regards to a specific reference geographical position.\n"
  "#  *\n"
  "#  * The value shall be set to:\n"
  "#  * - `-12 700` for values equal to or lower than -127 metres,\n"
  "#  * - `n` (`n > -12 700` and `n <= 0`) for altitude offset n x 0,01 metre below the reference position,\n"
  "#  * - `0` for no altitudinal offset,\n"
  "#  * - `n` (`n > 0` and `n < 12799`) for altitude offset n x 0,01 metre above the reference position,\n"
  "#  * - `12 799` for values equal to or greater than 127,99 metres,\n"
  "#  * - `12 800` when the information is unavailable.\n"
  "#  *\n"
  "#  * @unit: 0,01 metre\n"
  "#  * @category: GeoReference information\n"
  "#  * @revision: editorial update in V2.1.1\n"
  "#  */\n"
  "# DeltaAltitude ::= INTEGER {\n"
  "#     negativeOutOfRange (-12700),\n"
  "#     positiveOutOfRange (12799),\n"
  "#     unavailable        (12800)\n"
  "# } (-12700..12800)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "int16 value\n"
  "int16 MIN = -12700\n"
  "int16 MAX = 12800\n"
  "int16 NEGATIVE_OUT_OF_RANGE = -12700\n"
  "int16 POSITIVE_OUT_OF_RANGE = 12799\n"
  "int16 UNAVAILABLE = 12800\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__DeltaAltitude__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__DeltaAltitude__TYPE_NAME, 39, 39},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2974, 2974},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__DeltaAltitude__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__DeltaAltitude__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
