// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/EmergencyVehicleApproachingSubCauseCode.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/emergency_vehicle_approaching_sub_cause_code__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__EmergencyVehicleApproachingSubCauseCode__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x59, 0xba, 0x6b, 0x5f, 0x55, 0xfd, 0x57, 0x49,
      0x24, 0x1b, 0xa5, 0xee, 0xbe, 0x3f, 0x17, 0xb3,
      0x6d, 0x13, 0x7c, 0xd0, 0x46, 0xf3, 0x66, 0x66,
      0xa2, 0xae, 0x1a, 0xec, 0x22, 0xe3, 0xc2, 0x25,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__EmergencyVehicleApproachingSubCauseCode__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/EmergencyVehicleApproachingSubCauseCode";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__EmergencyVehicleApproachingSubCauseCode__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__EmergencyVehicleApproachingSubCauseCode__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__EmergencyVehicleApproachingSubCauseCode__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__EmergencyVehicleApproachingSubCauseCode__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__EmergencyVehicleApproachingSubCauseCode__TYPE_NAME, 65, 65},
      {etsi_its_denm_ts_msgs__msg__EmergencyVehicleApproachingSubCauseCode__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents the value of the sub cause codes of the @ref CauseCode \"emergencyVehicleApproaching\". \n"
  "#  * \n"
  "#  * The value shall be set to:\n"
  "#  * - 0 - `unavailable`                   - in case further detailed information on the emergency vehicle approaching event \n"
  "#  *                                         is unavailable,\n"
  "#  * - 1 - `emergencyVehicleApproaching`   - in case an operating emergency vehicle is approaching,\n"
  "#  * - 2 - `prioritizedVehicleApproaching` - in case a prioritized vehicle is approaching,\n"
  "#  * - 3-255                               - reserved for future usage.\n"
  "#  *\n"
  "#  * @category: Traffic information\n"
  "#  * @revision: V1.3.1\n"
  "#  */\n"
  "# EmergencyVehicleApproachingSubCauseCode ::= INTEGER {\n"
  "#     unavailable                   (0), \n"
  "#     emergencyVehicleApproaching   (1), \n"
  "#     prioritizedVehicleApproaching (2)\n"
  "# } (0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 EMERGENCY_VEHICLE_APPROACHING = 1\n"
  "uint8 PRIORITIZED_VEHICLE_APPROACHING = 2\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__EmergencyVehicleApproachingSubCauseCode__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__EmergencyVehicleApproachingSubCauseCode__TYPE_NAME, 65, 65},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2900, 2900},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__EmergencyVehicleApproachingSubCauseCode__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__EmergencyVehicleApproachingSubCauseCode__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
