// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_denm_ts_msgs:msg/GeoPosition.idl
// generated code does not contain a copyright notice
#include "etsi_its_denm_ts_msgs/msg/detail/geo_position__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `latitude`
#include "etsi_its_denm_ts_msgs/msg/detail/latitude__functions.h"
// Member `longitude`
#include "etsi_its_denm_ts_msgs/msg/detail/longitude__functions.h"
// Member `altitude`
#include "etsi_its_denm_ts_msgs/msg/detail/altitude_value__functions.h"

bool
etsi_its_denm_ts_msgs__msg__GeoPosition__init(etsi_its_denm_ts_msgs__msg__GeoPosition * msg)
{
  if (!msg) {
    return false;
  }
  // latitude
  if (!etsi_its_denm_ts_msgs__msg__Latitude__init(&msg->latitude)) {
    etsi_its_denm_ts_msgs__msg__GeoPosition__fini(msg);
    return false;
  }
  // longitude
  if (!etsi_its_denm_ts_msgs__msg__Longitude__init(&msg->longitude)) {
    etsi_its_denm_ts_msgs__msg__GeoPosition__fini(msg);
    return false;
  }
  // altitude
  if (!etsi_its_denm_ts_msgs__msg__AltitudeValue__init(&msg->altitude)) {
    etsi_its_denm_ts_msgs__msg__GeoPosition__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_denm_ts_msgs__msg__GeoPosition__fini(etsi_its_denm_ts_msgs__msg__GeoPosition * msg)
{
  if (!msg) {
    return;
  }
  // latitude
  etsi_its_denm_ts_msgs__msg__Latitude__fini(&msg->latitude);
  // longitude
  etsi_its_denm_ts_msgs__msg__Longitude__fini(&msg->longitude);
  // altitude
  etsi_its_denm_ts_msgs__msg__AltitudeValue__fini(&msg->altitude);
}

bool
etsi_its_denm_ts_msgs__msg__GeoPosition__are_equal(const etsi_its_denm_ts_msgs__msg__GeoPosition * lhs, const etsi_its_denm_ts_msgs__msg__GeoPosition * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // latitude
  if (!etsi_its_denm_ts_msgs__msg__Latitude__are_equal(
      &(lhs->latitude), &(rhs->latitude)))
  {
    return false;
  }
  // longitude
  if (!etsi_its_denm_ts_msgs__msg__Longitude__are_equal(
      &(lhs->longitude), &(rhs->longitude)))
  {
    return false;
  }
  // altitude
  if (!etsi_its_denm_ts_msgs__msg__AltitudeValue__are_equal(
      &(lhs->altitude), &(rhs->altitude)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__GeoPosition__copy(
  const etsi_its_denm_ts_msgs__msg__GeoPosition * input,
  etsi_its_denm_ts_msgs__msg__GeoPosition * output)
{
  if (!input || !output) {
    return false;
  }
  // latitude
  if (!etsi_its_denm_ts_msgs__msg__Latitude__copy(
      &(input->latitude), &(output->latitude)))
  {
    return false;
  }
  // longitude
  if (!etsi_its_denm_ts_msgs__msg__Longitude__copy(
      &(input->longitude), &(output->longitude)))
  {
    return false;
  }
  // altitude
  if (!etsi_its_denm_ts_msgs__msg__AltitudeValue__copy(
      &(input->altitude), &(output->altitude)))
  {
    return false;
  }
  return true;
}

etsi_its_denm_ts_msgs__msg__GeoPosition *
etsi_its_denm_ts_msgs__msg__GeoPosition__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__GeoPosition * msg = (etsi_its_denm_ts_msgs__msg__GeoPosition *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__GeoPosition), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_denm_ts_msgs__msg__GeoPosition));
  bool success = etsi_its_denm_ts_msgs__msg__GeoPosition__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_denm_ts_msgs__msg__GeoPosition__destroy(etsi_its_denm_ts_msgs__msg__GeoPosition * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_denm_ts_msgs__msg__GeoPosition__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence__init(etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__GeoPosition * data = NULL;

  if (size) {
    data = (etsi_its_denm_ts_msgs__msg__GeoPosition *)allocator.zero_allocate(size, sizeof(etsi_its_denm_ts_msgs__msg__GeoPosition), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_denm_ts_msgs__msg__GeoPosition__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_denm_ts_msgs__msg__GeoPosition__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence__fini(etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_denm_ts_msgs__msg__GeoPosition__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence *
etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence * array = (etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence__destroy(etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence__are_equal(const etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence * lhs, const etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__GeoPosition__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence__copy(
  const etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence * input,
  etsi_its_denm_ts_msgs__msg__GeoPosition__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_denm_ts_msgs__msg__GeoPosition);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_denm_ts_msgs__msg__GeoPosition * data =
      (etsi_its_denm_ts_msgs__msg__GeoPosition *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_denm_ts_msgs__msg__GeoPosition__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_denm_ts_msgs__msg__GeoPosition__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__GeoPosition__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
