// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_denm_ts_msgs:msg/LanePositionOptions.idl
// generated code does not contain a copyright notice
#include "etsi_its_denm_ts_msgs/msg/detail/lane_position_options__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `simplelane_position`
#include "etsi_its_denm_ts_msgs/msg/detail/lane_position__functions.h"
// Member `simple_lane_type`
#include "etsi_its_denm_ts_msgs/msg/detail/lane_type__functions.h"
// Member `detailedlane_position`
#include "etsi_its_denm_ts_msgs/msg/detail/lane_position_and_type__functions.h"
// Member `lane_position_with_lateral_details`
#include "etsi_its_denm_ts_msgs/msg/detail/lane_position_with_lateral_details__functions.h"
// Member `traffic_island_position`
#include "etsi_its_denm_ts_msgs/msg/detail/traffic_island_position__functions.h"

bool
etsi_its_denm_ts_msgs__msg__LanePositionOptions__init(etsi_its_denm_ts_msgs__msg__LanePositionOptions * msg)
{
  if (!msg) {
    return false;
  }
  // choice
  // simplelane_position
  if (!etsi_its_denm_ts_msgs__msg__LanePosition__init(&msg->simplelane_position)) {
    etsi_its_denm_ts_msgs__msg__LanePositionOptions__fini(msg);
    return false;
  }
  // simple_lane_type
  if (!etsi_its_denm_ts_msgs__msg__LaneType__init(&msg->simple_lane_type)) {
    etsi_its_denm_ts_msgs__msg__LanePositionOptions__fini(msg);
    return false;
  }
  // detailedlane_position
  if (!etsi_its_denm_ts_msgs__msg__LanePositionAndType__init(&msg->detailedlane_position)) {
    etsi_its_denm_ts_msgs__msg__LanePositionOptions__fini(msg);
    return false;
  }
  // lane_position_with_lateral_details
  if (!etsi_its_denm_ts_msgs__msg__LanePositionWithLateralDetails__init(&msg->lane_position_with_lateral_details)) {
    etsi_its_denm_ts_msgs__msg__LanePositionOptions__fini(msg);
    return false;
  }
  // traffic_island_position
  if (!etsi_its_denm_ts_msgs__msg__TrafficIslandPosition__init(&msg->traffic_island_position)) {
    etsi_its_denm_ts_msgs__msg__LanePositionOptions__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_denm_ts_msgs__msg__LanePositionOptions__fini(etsi_its_denm_ts_msgs__msg__LanePositionOptions * msg)
{
  if (!msg) {
    return;
  }
  // choice
  // simplelane_position
  etsi_its_denm_ts_msgs__msg__LanePosition__fini(&msg->simplelane_position);
  // simple_lane_type
  etsi_its_denm_ts_msgs__msg__LaneType__fini(&msg->simple_lane_type);
  // detailedlane_position
  etsi_its_denm_ts_msgs__msg__LanePositionAndType__fini(&msg->detailedlane_position);
  // lane_position_with_lateral_details
  etsi_its_denm_ts_msgs__msg__LanePositionWithLateralDetails__fini(&msg->lane_position_with_lateral_details);
  // traffic_island_position
  etsi_its_denm_ts_msgs__msg__TrafficIslandPosition__fini(&msg->traffic_island_position);
}

bool
etsi_its_denm_ts_msgs__msg__LanePositionOptions__are_equal(const etsi_its_denm_ts_msgs__msg__LanePositionOptions * lhs, const etsi_its_denm_ts_msgs__msg__LanePositionOptions * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // choice
  if (lhs->choice != rhs->choice) {
    return false;
  }
  // simplelane_position
  if (!etsi_its_denm_ts_msgs__msg__LanePosition__are_equal(
      &(lhs->simplelane_position), &(rhs->simplelane_position)))
  {
    return false;
  }
  // simple_lane_type
  if (!etsi_its_denm_ts_msgs__msg__LaneType__are_equal(
      &(lhs->simple_lane_type), &(rhs->simple_lane_type)))
  {
    return false;
  }
  // detailedlane_position
  if (!etsi_its_denm_ts_msgs__msg__LanePositionAndType__are_equal(
      &(lhs->detailedlane_position), &(rhs->detailedlane_position)))
  {
    return false;
  }
  // lane_position_with_lateral_details
  if (!etsi_its_denm_ts_msgs__msg__LanePositionWithLateralDetails__are_equal(
      &(lhs->lane_position_with_lateral_details), &(rhs->lane_position_with_lateral_details)))
  {
    return false;
  }
  // traffic_island_position
  if (!etsi_its_denm_ts_msgs__msg__TrafficIslandPosition__are_equal(
      &(lhs->traffic_island_position), &(rhs->traffic_island_position)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__LanePositionOptions__copy(
  const etsi_its_denm_ts_msgs__msg__LanePositionOptions * input,
  etsi_its_denm_ts_msgs__msg__LanePositionOptions * output)
{
  if (!input || !output) {
    return false;
  }
  // choice
  output->choice = input->choice;
  // simplelane_position
  if (!etsi_its_denm_ts_msgs__msg__LanePosition__copy(
      &(input->simplelane_position), &(output->simplelane_position)))
  {
    return false;
  }
  // simple_lane_type
  if (!etsi_its_denm_ts_msgs__msg__LaneType__copy(
      &(input->simple_lane_type), &(output->simple_lane_type)))
  {
    return false;
  }
  // detailedlane_position
  if (!etsi_its_denm_ts_msgs__msg__LanePositionAndType__copy(
      &(input->detailedlane_position), &(output->detailedlane_position)))
  {
    return false;
  }
  // lane_position_with_lateral_details
  if (!etsi_its_denm_ts_msgs__msg__LanePositionWithLateralDetails__copy(
      &(input->lane_position_with_lateral_details), &(output->lane_position_with_lateral_details)))
  {
    return false;
  }
  // traffic_island_position
  if (!etsi_its_denm_ts_msgs__msg__TrafficIslandPosition__copy(
      &(input->traffic_island_position), &(output->traffic_island_position)))
  {
    return false;
  }
  return true;
}

etsi_its_denm_ts_msgs__msg__LanePositionOptions *
etsi_its_denm_ts_msgs__msg__LanePositionOptions__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__LanePositionOptions * msg = (etsi_its_denm_ts_msgs__msg__LanePositionOptions *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__LanePositionOptions), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_denm_ts_msgs__msg__LanePositionOptions));
  bool success = etsi_its_denm_ts_msgs__msg__LanePositionOptions__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_denm_ts_msgs__msg__LanePositionOptions__destroy(etsi_its_denm_ts_msgs__msg__LanePositionOptions * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_denm_ts_msgs__msg__LanePositionOptions__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence__init(etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__LanePositionOptions * data = NULL;

  if (size) {
    data = (etsi_its_denm_ts_msgs__msg__LanePositionOptions *)allocator.zero_allocate(size, sizeof(etsi_its_denm_ts_msgs__msg__LanePositionOptions), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_denm_ts_msgs__msg__LanePositionOptions__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_denm_ts_msgs__msg__LanePositionOptions__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence__fini(etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_denm_ts_msgs__msg__LanePositionOptions__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence *
etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence * array = (etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence__destroy(etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence__are_equal(const etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence * lhs, const etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__LanePositionOptions__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence__copy(
  const etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence * input,
  etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_denm_ts_msgs__msg__LanePositionOptions);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_denm_ts_msgs__msg__LanePositionOptions * data =
      (etsi_its_denm_ts_msgs__msg__LanePositionOptions *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_denm_ts_msgs__msg__LanePositionOptions__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_denm_ts_msgs__msg__LanePositionOptions__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__LanePositionOptions__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
