// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/LocationContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/location_container.hpp"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LOCATION_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LOCATION_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'event_speed'
#include "etsi_its_denm_ts_msgs/msg/detail/speed__struct.hpp"
// Member 'event_position_heading'
#include "etsi_its_denm_ts_msgs/msg/detail/wgs84_angle__struct.hpp"
// Member 'detection_zones_to_event_position'
#include "etsi_its_denm_ts_msgs/msg/detail/traces__struct.hpp"
// Member 'road_type'
#include "etsi_its_denm_ts_msgs/msg/detail/road_type__struct.hpp"
// Member 'lane_positions'
#include "etsi_its_denm_ts_msgs/msg/detail/generalized_lane_positions__struct.hpp"
// Member 'occupied_lanes'
#include "etsi_its_denm_ts_msgs/msg/detail/occupied_lanes_with_confidence__struct.hpp"
// Member 'linked_ivims'
#include "etsi_its_denm_ts_msgs/msg/detail/ivim_references__struct.hpp"
// Member 'linked_mapems'
#include "etsi_its_denm_ts_msgs/msg/detail/map_references__struct.hpp"
// Member 'detection_zones_to_specified_event_point'
#include "etsi_its_denm_ts_msgs/msg/detail/traces_extended__struct.hpp"
// Member 'predicted_paths'
#include "etsi_its_denm_ts_msgs/msg/detail/path_predicted_list__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__LocationContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__LocationContainer __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LocationContainer_
{
  using Type = LocationContainer_<ContainerAllocator>;

  explicit LocationContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : event_speed(_init),
    event_position_heading(_init),
    detection_zones_to_event_position(_init),
    road_type(_init),
    lane_positions(_init),
    occupied_lanes(_init),
    linked_ivims(_init),
    linked_mapems(_init),
    detection_zones_to_specified_event_point(_init),
    predicted_paths(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->event_speed_is_present = false;
      this->event_position_heading_is_present = false;
      this->road_type_is_present = false;
      this->lane_positions_is_present = false;
      this->occupied_lanes_is_present = false;
      this->linked_ivims_is_present = false;
      this->linked_mapems_is_present = false;
      this->detection_zones_to_specified_event_point_is_present = false;
      this->predicted_paths_is_present = false;
    }
  }

  explicit LocationContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : event_speed(_alloc, _init),
    event_position_heading(_alloc, _init),
    detection_zones_to_event_position(_alloc, _init),
    road_type(_alloc, _init),
    lane_positions(_alloc, _init),
    occupied_lanes(_alloc, _init),
    linked_ivims(_alloc, _init),
    linked_mapems(_alloc, _init),
    detection_zones_to_specified_event_point(_alloc, _init),
    predicted_paths(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->event_speed_is_present = false;
      this->event_position_heading_is_present = false;
      this->road_type_is_present = false;
      this->lane_positions_is_present = false;
      this->occupied_lanes_is_present = false;
      this->linked_ivims_is_present = false;
      this->linked_mapems_is_present = false;
      this->detection_zones_to_specified_event_point_is_present = false;
      this->predicted_paths_is_present = false;
    }
  }

  // field types and members
  using _event_speed_type =
    etsi_its_denm_ts_msgs::msg::Speed_<ContainerAllocator>;
  _event_speed_type event_speed;
  using _event_speed_is_present_type =
    bool;
  _event_speed_is_present_type event_speed_is_present;
  using _event_position_heading_type =
    etsi_its_denm_ts_msgs::msg::Wgs84Angle_<ContainerAllocator>;
  _event_position_heading_type event_position_heading;
  using _event_position_heading_is_present_type =
    bool;
  _event_position_heading_is_present_type event_position_heading_is_present;
  using _detection_zones_to_event_position_type =
    etsi_its_denm_ts_msgs::msg::Traces_<ContainerAllocator>;
  _detection_zones_to_event_position_type detection_zones_to_event_position;
  using _road_type_type =
    etsi_its_denm_ts_msgs::msg::RoadType_<ContainerAllocator>;
  _road_type_type road_type;
  using _road_type_is_present_type =
    bool;
  _road_type_is_present_type road_type_is_present;
  using _lane_positions_type =
    etsi_its_denm_ts_msgs::msg::GeneralizedLanePositions_<ContainerAllocator>;
  _lane_positions_type lane_positions;
  using _lane_positions_is_present_type =
    bool;
  _lane_positions_is_present_type lane_positions_is_present;
  using _occupied_lanes_type =
    etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence_<ContainerAllocator>;
  _occupied_lanes_type occupied_lanes;
  using _occupied_lanes_is_present_type =
    bool;
  _occupied_lanes_is_present_type occupied_lanes_is_present;
  using _linked_ivims_type =
    etsi_its_denm_ts_msgs::msg::IvimReferences_<ContainerAllocator>;
  _linked_ivims_type linked_ivims;
  using _linked_ivims_is_present_type =
    bool;
  _linked_ivims_is_present_type linked_ivims_is_present;
  using _linked_mapems_type =
    etsi_its_denm_ts_msgs::msg::MapReferences_<ContainerAllocator>;
  _linked_mapems_type linked_mapems;
  using _linked_mapems_is_present_type =
    bool;
  _linked_mapems_is_present_type linked_mapems_is_present;
  using _detection_zones_to_specified_event_point_type =
    etsi_its_denm_ts_msgs::msg::TracesExtended_<ContainerAllocator>;
  _detection_zones_to_specified_event_point_type detection_zones_to_specified_event_point;
  using _detection_zones_to_specified_event_point_is_present_type =
    bool;
  _detection_zones_to_specified_event_point_is_present_type detection_zones_to_specified_event_point_is_present;
  using _predicted_paths_type =
    etsi_its_denm_ts_msgs::msg::PathPredictedList_<ContainerAllocator>;
  _predicted_paths_type predicted_paths;
  using _predicted_paths_is_present_type =
    bool;
  _predicted_paths_is_present_type predicted_paths_is_present;

  // setters for named parameter idiom
  Type & set__event_speed(
    const etsi_its_denm_ts_msgs::msg::Speed_<ContainerAllocator> & _arg)
  {
    this->event_speed = _arg;
    return *this;
  }
  Type & set__event_speed_is_present(
    const bool & _arg)
  {
    this->event_speed_is_present = _arg;
    return *this;
  }
  Type & set__event_position_heading(
    const etsi_its_denm_ts_msgs::msg::Wgs84Angle_<ContainerAllocator> & _arg)
  {
    this->event_position_heading = _arg;
    return *this;
  }
  Type & set__event_position_heading_is_present(
    const bool & _arg)
  {
    this->event_position_heading_is_present = _arg;
    return *this;
  }
  Type & set__detection_zones_to_event_position(
    const etsi_its_denm_ts_msgs::msg::Traces_<ContainerAllocator> & _arg)
  {
    this->detection_zones_to_event_position = _arg;
    return *this;
  }
  Type & set__road_type(
    const etsi_its_denm_ts_msgs::msg::RoadType_<ContainerAllocator> & _arg)
  {
    this->road_type = _arg;
    return *this;
  }
  Type & set__road_type_is_present(
    const bool & _arg)
  {
    this->road_type_is_present = _arg;
    return *this;
  }
  Type & set__lane_positions(
    const etsi_its_denm_ts_msgs::msg::GeneralizedLanePositions_<ContainerAllocator> & _arg)
  {
    this->lane_positions = _arg;
    return *this;
  }
  Type & set__lane_positions_is_present(
    const bool & _arg)
  {
    this->lane_positions_is_present = _arg;
    return *this;
  }
  Type & set__occupied_lanes(
    const etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence_<ContainerAllocator> & _arg)
  {
    this->occupied_lanes = _arg;
    return *this;
  }
  Type & set__occupied_lanes_is_present(
    const bool & _arg)
  {
    this->occupied_lanes_is_present = _arg;
    return *this;
  }
  Type & set__linked_ivims(
    const etsi_its_denm_ts_msgs::msg::IvimReferences_<ContainerAllocator> & _arg)
  {
    this->linked_ivims = _arg;
    return *this;
  }
  Type & set__linked_ivims_is_present(
    const bool & _arg)
  {
    this->linked_ivims_is_present = _arg;
    return *this;
  }
  Type & set__linked_mapems(
    const etsi_its_denm_ts_msgs::msg::MapReferences_<ContainerAllocator> & _arg)
  {
    this->linked_mapems = _arg;
    return *this;
  }
  Type & set__linked_mapems_is_present(
    const bool & _arg)
  {
    this->linked_mapems_is_present = _arg;
    return *this;
  }
  Type & set__detection_zones_to_specified_event_point(
    const etsi_its_denm_ts_msgs::msg::TracesExtended_<ContainerAllocator> & _arg)
  {
    this->detection_zones_to_specified_event_point = _arg;
    return *this;
  }
  Type & set__detection_zones_to_specified_event_point_is_present(
    const bool & _arg)
  {
    this->detection_zones_to_specified_event_point_is_present = _arg;
    return *this;
  }
  Type & set__predicted_paths(
    const etsi_its_denm_ts_msgs::msg::PathPredictedList_<ContainerAllocator> & _arg)
  {
    this->predicted_paths = _arg;
    return *this;
  }
  Type & set__predicted_paths_is_present(
    const bool & _arg)
  {
    this->predicted_paths_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::LocationContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::LocationContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::LocationContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::LocationContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::LocationContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::LocationContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::LocationContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::LocationContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::LocationContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::LocationContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__LocationContainer
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::LocationContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__LocationContainer
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::LocationContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LocationContainer_ & other) const
  {
    if (this->event_speed != other.event_speed) {
      return false;
    }
    if (this->event_speed_is_present != other.event_speed_is_present) {
      return false;
    }
    if (this->event_position_heading != other.event_position_heading) {
      return false;
    }
    if (this->event_position_heading_is_present != other.event_position_heading_is_present) {
      return false;
    }
    if (this->detection_zones_to_event_position != other.detection_zones_to_event_position) {
      return false;
    }
    if (this->road_type != other.road_type) {
      return false;
    }
    if (this->road_type_is_present != other.road_type_is_present) {
      return false;
    }
    if (this->lane_positions != other.lane_positions) {
      return false;
    }
    if (this->lane_positions_is_present != other.lane_positions_is_present) {
      return false;
    }
    if (this->occupied_lanes != other.occupied_lanes) {
      return false;
    }
    if (this->occupied_lanes_is_present != other.occupied_lanes_is_present) {
      return false;
    }
    if (this->linked_ivims != other.linked_ivims) {
      return false;
    }
    if (this->linked_ivims_is_present != other.linked_ivims_is_present) {
      return false;
    }
    if (this->linked_mapems != other.linked_mapems) {
      return false;
    }
    if (this->linked_mapems_is_present != other.linked_mapems_is_present) {
      return false;
    }
    if (this->detection_zones_to_specified_event_point != other.detection_zones_to_specified_event_point) {
      return false;
    }
    if (this->detection_zones_to_specified_event_point_is_present != other.detection_zones_to_specified_event_point_is_present) {
      return false;
    }
    if (this->predicted_paths != other.predicted_paths) {
      return false;
    }
    if (this->predicted_paths_is_present != other.predicted_paths_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const LocationContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LocationContainer_

// alias to use template instance with default allocator
using LocationContainer =
  etsi_its_denm_ts_msgs::msg::LocationContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LOCATION_CONTAINER__STRUCT_HPP_
