// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/OccupiedLanesWithConfidence.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/occupied_lanes_with_confidence.hpp"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__OCCUPIED_LANES_WITH_CONFIDENCE__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__OCCUPIED_LANES_WITH_CONFIDENCE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'lane_position_based'
#include "etsi_its_denm_ts_msgs/msg/detail/lane_position_options__struct.hpp"
// Member 'map_based'
#include "etsi_its_denm_ts_msgs/msg/detail/map_position__struct.hpp"
// Member 'confidence'
#include "etsi_its_denm_ts_msgs/msg/detail/meta_information__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__OccupiedLanesWithConfidence __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__OccupiedLanesWithConfidence __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct OccupiedLanesWithConfidence_
{
  using Type = OccupiedLanesWithConfidence_<ContainerAllocator>;

  explicit OccupiedLanesWithConfidence_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : confidence(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->map_based_is_present = false;
    }
  }

  explicit OccupiedLanesWithConfidence_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : confidence(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->map_based_is_present = false;
    }
  }

  // field types and members
  using _lane_position_based_type =
    std::vector<etsi_its_denm_ts_msgs::msg::LanePositionOptions_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<etsi_its_denm_ts_msgs::msg::LanePositionOptions_<ContainerAllocator>>>;
  _lane_position_based_type lane_position_based;
  using _map_based_type =
    std::vector<etsi_its_denm_ts_msgs::msg::MapPosition_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<etsi_its_denm_ts_msgs::msg::MapPosition_<ContainerAllocator>>>;
  _map_based_type map_based;
  using _map_based_is_present_type =
    bool;
  _map_based_is_present_type map_based_is_present;
  using _confidence_type =
    etsi_its_denm_ts_msgs::msg::MetaInformation_<ContainerAllocator>;
  _confidence_type confidence;

  // setters for named parameter idiom
  Type & set__lane_position_based(
    const std::vector<etsi_its_denm_ts_msgs::msg::LanePositionOptions_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<etsi_its_denm_ts_msgs::msg::LanePositionOptions_<ContainerAllocator>>> & _arg)
  {
    this->lane_position_based = _arg;
    return *this;
  }
  Type & set__map_based(
    const std::vector<etsi_its_denm_ts_msgs::msg::MapPosition_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<etsi_its_denm_ts_msgs::msg::MapPosition_<ContainerAllocator>>> & _arg)
  {
    this->map_based = _arg;
    return *this;
  }
  Type & set__map_based_is_present(
    const bool & _arg)
  {
    this->map_based_is_present = _arg;
    return *this;
  }
  Type & set__confidence(
    const etsi_its_denm_ts_msgs::msg::MetaInformation_<ContainerAllocator> & _arg)
  {
    this->confidence = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t LANE_POSITION_BASED_MIN_SIZE =
    1u;
  static constexpr uint8_t LANE_POSITION_BASED_MAX_SIZE =
    4u;
  static constexpr uint8_t MAP_BASED_MIN_SIZE =
    1u;
  static constexpr uint8_t MAP_BASED_MAX_SIZE =
    4u;

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__OccupiedLanesWithConfidence
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__OccupiedLanesWithConfidence
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const OccupiedLanesWithConfidence_ & other) const
  {
    if (this->lane_position_based != other.lane_position_based) {
      return false;
    }
    if (this->map_based != other.map_based) {
      return false;
    }
    if (this->map_based_is_present != other.map_based_is_present) {
      return false;
    }
    if (this->confidence != other.confidence) {
      return false;
    }
    return true;
  }
  bool operator!=(const OccupiedLanesWithConfidence_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct OccupiedLanesWithConfidence_

// alias to use template instance with default allocator
using OccupiedLanesWithConfidence =
  etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t OccupiedLanesWithConfidence_<ContainerAllocator>::LANE_POSITION_BASED_MIN_SIZE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t OccupiedLanesWithConfidence_<ContainerAllocator>::LANE_POSITION_BASED_MAX_SIZE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t OccupiedLanesWithConfidence_<ContainerAllocator>::MAP_BASED_MIN_SIZE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t OccupiedLanesWithConfidence_<ContainerAllocator>::MAP_BASED_MAX_SIZE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__OCCUPIED_LANES_WITH_CONFIDENCE__STRUCT_HPP_
