// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/PositioningSolutionType.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/positioning_solution_type__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__PositioningSolutionType__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xde, 0xbd, 0xc5, 0xa4, 0xd1, 0x8c, 0x1b, 0x6f,
      0x06, 0xf6, 0xb6, 0xe0, 0xb9, 0xdd, 0x9f, 0x34,
      0x87, 0x86, 0xfd, 0xa5, 0xa4, 0x47, 0x47, 0x1b,
      0x6d, 0x61, 0x88, 0x3b, 0x52, 0x60, 0x75, 0xec,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__PositioningSolutionType__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/PositioningSolutionType";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__PositioningSolutionType__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__PositioningSolutionType__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__PositioningSolutionType__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__PositioningSolutionType__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__PositioningSolutionType__TYPE_NAME, 49, 49},
      {etsi_its_denm_ts_msgs__msg__PositioningSolutionType__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE indicates the positioning technology being used to estimate a geographical position.\n"
  "#  *\n"
  "#  * The value shall be set to:\n"
  "#  * - 0 `noPositioningSolution`  - no positioning solution used,\n"
  "#  * - 1 `sGNSS`                  - Global Navigation Satellite System used,\n"
  "#  * - 2 `dGNSS`                  - Differential GNSS used,\n"
  "#  * - 3 `sGNSSplusDR`            - GNSS and dead reckoning used,\n"
  "#  * - 4 `dGNSSplusDR`            - Differential GNSS and dead reckoning used,\n"
  "#  * - 5 `dR`                     - dead reckoning used,\n"
  "#  * - 6 `manuallyByOperator`     - position set manually by a human operator.\n"
  "#  *\n"
  "#  * @category: GeoReference information\n"
  "#  * @revision: V1.3.1, extension with value 6 added in V2.2.1\n"
  "#  */\n"
  "# PositioningSolutionType ::= ENUMERATED {\n"
  "#     noPositioningSolution (0), \n"
  "#     sGNSS                 (1), \n"
  "#     dGNSS                 (2), \n"
  "#     sGNSSplusDR           (3), \n"
  "#     dGNSSplusDR           (4), \n"
  "#     dR                    (5), \n"
  "#     ...,\n"
  "#     manuallyByOperator    (6)\n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 NO_POSITIONING_SOLUTION = 0\n"
  "uint8 S_GNSS = 1\n"
  "uint8 D_GNSS = 2\n"
  "uint8 S_GNS_SPLUS_DR = 3\n"
  "uint8 D_GNS_SPLUS_DR = 4\n"
  "uint8 D_R = 5\n"
  "uint8 MANUALLY_BY_OPERATOR = 6\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__PositioningSolutionType__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__PositioningSolutionType__TYPE_NAME, 49, 49},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3095, 3095},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__PositioningSolutionType__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__PositioningSolutionType__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
