// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/PreCrashContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/pre_crash_container.hpp"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PRE_CRASH_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PRE_CRASH_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_ts_msgs/msg/detail/pre_crash_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'perceived_pre_crash_object'
#include "etsi_its_denm_ts_msgs/msg/detail/perceived_object__traits.hpp"
// Member 'object_station_id'
#include "etsi_its_denm_ts_msgs/msg/detail/station_id__traits.hpp"
// Member 'time_to_collision'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_time_milli_second_positive__traits.hpp"
// Member 'impact_section'
#include "etsi_its_denm_ts_msgs/msg/detail/object_face__traits.hpp"
// Member 'estimated_braking_distance'
#include "etsi_its_denm_ts_msgs/msg/detail/standard_length12b__traits.hpp"

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PreCrashContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: perceived_pre_crash_object
  {
    out << "perceived_pre_crash_object: ";
    to_flow_style_yaml(msg.perceived_pre_crash_object, out);
    out << ", ";
  }

  // member: object_station_id
  {
    out << "object_station_id: ";
    to_flow_style_yaml(msg.object_station_id, out);
    out << ", ";
  }

  // member: object_station_id_is_present
  {
    out << "object_station_id_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.object_station_id_is_present, out);
    out << ", ";
  }

  // member: time_to_collision
  {
    out << "time_to_collision: ";
    to_flow_style_yaml(msg.time_to_collision, out);
    out << ", ";
  }

  // member: time_to_collision_is_present
  {
    out << "time_to_collision_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.time_to_collision_is_present, out);
    out << ", ";
  }

  // member: impact_section
  {
    out << "impact_section: ";
    to_flow_style_yaml(msg.impact_section, out);
    out << ", ";
  }

  // member: impact_section_is_present
  {
    out << "impact_section_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.impact_section_is_present, out);
    out << ", ";
  }

  // member: estimated_braking_distance
  {
    out << "estimated_braking_distance: ";
    to_flow_style_yaml(msg.estimated_braking_distance, out);
    out << ", ";
  }

  // member: estimated_braking_distance_is_present
  {
    out << "estimated_braking_distance_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.estimated_braking_distance_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PreCrashContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: perceived_pre_crash_object
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "perceived_pre_crash_object:\n";
    to_block_style_yaml(msg.perceived_pre_crash_object, out, indentation + 2);
  }

  // member: object_station_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_station_id:\n";
    to_block_style_yaml(msg.object_station_id, out, indentation + 2);
  }

  // member: object_station_id_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_station_id_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.object_station_id_is_present, out);
    out << "\n";
  }

  // member: time_to_collision
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_to_collision:\n";
    to_block_style_yaml(msg.time_to_collision, out, indentation + 2);
  }

  // member: time_to_collision_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_to_collision_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.time_to_collision_is_present, out);
    out << "\n";
  }

  // member: impact_section
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "impact_section:\n";
    to_block_style_yaml(msg.impact_section, out, indentation + 2);
  }

  // member: impact_section_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "impact_section_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.impact_section_is_present, out);
    out << "\n";
  }

  // member: estimated_braking_distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "estimated_braking_distance:\n";
    to_block_style_yaml(msg.estimated_braking_distance, out, indentation + 2);
  }

  // member: estimated_braking_distance_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "estimated_braking_distance_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.estimated_braking_distance_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PreCrashContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_ts_msgs::msg::PreCrashContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_ts_msgs::msg::PreCrashContainer & msg)
{
  return etsi_its_denm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_ts_msgs::msg::PreCrashContainer>()
{
  return "etsi_its_denm_ts_msgs::msg::PreCrashContainer";
}

template<>
inline const char * name<etsi_its_denm_ts_msgs::msg::PreCrashContainer>()
{
  return "etsi_its_denm_ts_msgs/msg/PreCrashContainer";
}

template<>
struct has_fixed_size<etsi_its_denm_ts_msgs::msg::PreCrashContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_ts_msgs::msg::DeltaTimeMilliSecondPositive>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::ObjectFace>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::PerceivedObject>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::StandardLength12b>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::StationId>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_ts_msgs::msg::PreCrashContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_ts_msgs::msg::DeltaTimeMilliSecondPositive>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::ObjectFace>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::PerceivedObject>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::StandardLength12b>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::StationId>::value> {};

template<>
struct is_message<etsi_its_denm_ts_msgs::msg::PreCrashContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PRE_CRASH_CONTAINER__TRAITS_HPP_
