// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/SemiAxisLength.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/semi_axis_length__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__SemiAxisLength__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x0f, 0x6b, 0x82, 0x0d, 0x6c, 0x34, 0x51, 0xfe,
      0x66, 0xcd, 0xa0, 0xae, 0xd6, 0x8a, 0xef, 0xf7,
      0xbe, 0x8e, 0x1a, 0x57, 0xfa, 0x92, 0x21, 0x8a,
      0x57, 0x9c, 0x1a, 0xd4, 0xd7, 0xd7, 0xb8, 0xb7,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__SemiAxisLength__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/SemiAxisLength";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__SemiAxisLength__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__SemiAxisLength__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__SemiAxisLength__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__SemiAxisLength__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__SemiAxisLength__TYPE_NAME, 40, 40},
      {etsi_its_denm_ts_msgs__msg__SemiAxisLength__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE indicates the horizontal position confidence value which represents the estimated absolute position accuracy, in one of the axis direction as defined in a shape of ellipse with a \n"
  "#  * confidence level of 95 %. \n"
  "#  * \n"
  "#  * The value shall be set to:\n"
  "#  * - `n` (`n > 0` and `n < 4 094`) if the accuracy is equal to or less than n * 0,01 metre,\n"
  "#  * - `4 094` if the accuracy is out of range, i.e. greater than 4,093 m,\n"
  "#  * - `4 095` if the accuracy information is unavailable.\n"
  "#  *\n"
  "#  * The value 0 shall not be used.\n"
  "#  * \n"
  "#  * @note: The fact that a position coordinate value is received with confidence value set to `unavailable(4095)`.\n"
  "#  * can be caused by several reasons, such as:\n"
  "#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,\n"
  "#  * - the sensor cannot calculate the accuracy due to lack of variables, or\n"
  "#  * - there has been a vehicle bus (e.g. CAN bus) error.\n"
  "#  * In all 3 cases above, the position coordinate value may be valid and used by the application.\n"
  "#  * If a position coordinate value is received and its confidence value is set to `outOfRange(4094)`, it means that\n"
  "#  * the position coordinate value is not valid and therefore cannot be trusted. Such value is not useful\n"
  "#  * for the application.\n"
  "# \n"
  "#  * @unit 0,01 metre \n"
  "#  * @category: GeoReference Information\n"
  "#  * @revision: Description revised in V2.1.1\n"
  "#  */\n"
  "# SemiAxisLength ::= INTEGER{\n"
  "#     doNotUse    (0),\n"
  "#     outOfRange  (4094), \n"
  "#     unavailable (4095)\n"
  "# } (0..4095)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint16 value\n"
  "uint16 MIN = 0\n"
  "uint16 MAX = 4095\n"
  "uint16 DO_NOT_USE = 0\n"
  "uint16 OUT_OF_RANGE = 4094\n"
  "uint16 UNAVAILABLE = 4095\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__SemiAxisLength__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__SemiAxisLength__TYPE_NAME, 40, 40},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3546, 3546},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__SemiAxisLength__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__SemiAxisLength__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
