// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/SpeedValue.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/speed_value__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__SpeedValue__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x86, 0xe9, 0xa8, 0x1e, 0x76, 0xf7, 0x47, 0xfc,
      0xaa, 0xda, 0x3c, 0x18, 0x3c, 0xe2, 0x51, 0xee,
      0xa8, 0x2f, 0xc2, 0xfc, 0x91, 0xeb, 0x43, 0xeb,
      0xe9, 0xc9, 0x2f, 0xcb, 0x6f, 0x90, 0xe8, 0x0c,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__SpeedValue__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/SpeedValue";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__SpeedValue__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__SpeedValue__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__SpeedValue__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__SpeedValue__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__SpeedValue__TYPE_NAME, 36, 36},
      {etsi_its_denm_ts_msgs__msg__SpeedValue__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents a speed value, i.e. the magnitude of the velocity-vector. \n"
  "#  *\n"
  "#  * The value shall be set to:\n"
  "#  * - `0` in a standstill situation.\n"
  "#  * - `n` (`n > 0` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,\n"
  "#  * - `16 382` for speed values greater than 163,81 m/s,\n"
  "#  * - `16 383` if the speed accuracy information is not available.\n"
  "#  * \n"
  "#  * @note: the definition of standstill is out of scope of the present document.\n"
  "#  *\n"
  "#  * @unit: 0,01 m/s\n"
  "#  * @category: Kinematic information\n"
  "#  * @revision: Description revised in V2.1.1 (the meaning of 16382 has changed slightly) \n"
  "# */\n"
  "# SpeedValue ::= INTEGER {\n"
  "#     standstill  (0), \n"
  "#     outOfRange  (16382), \n"
  "#     unavailable (16383)\n"
  "# } (0..16383)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint16 value\n"
  "uint16 MIN = 0\n"
  "uint16 MAX = 16383\n"
  "uint16 STANDSTILL = 0\n"
  "uint16 OUT_OF_RANGE = 16382\n"
  "uint16 UNAVAILABLE = 16383\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__SpeedValue__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__SpeedValue__TYPE_NAME, 36, 36},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2804, 2804},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__SpeedValue__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__SpeedValue__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
