// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/TimestampIts.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/timestamp_its__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__TimestampIts__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xed, 0xd8, 0x12, 0x1c, 0xa3, 0x33, 0x62, 0xa0,
      0xf8, 0x7a, 0xf8, 0x31, 0xc6, 0xcb, 0xd0, 0x9d,
      0xfb, 0x2d, 0x9a, 0x60, 0xf1, 0xdd, 0xcb, 0xcd,
      0x61, 0x5e, 0xa9, 0x2a, 0x45, 0x46, 0xbb, 0x2e,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__TimestampIts__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/TimestampIts";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__TimestampIts__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__TimestampIts__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__TimestampIts__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT64,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__TimestampIts__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__TimestampIts__TYPE_NAME, 38, 38},
      {etsi_its_denm_ts_msgs__msg__TimestampIts__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents the number of elapsed (TAI) milliseconds since the ITS Epoch. \n"
  "#  * The ITS epoch is `00:00:00.000 UTC, 1 January 2004`.\n"
  "#  * \"Elapsed\" means that the true number of milliseconds is continuously counted without interruption,\n"
  "#  *  i.e. it is not altered by leap seconds, which occur in UTC.\n"
  "#  * \n"
  "#  * @note: International Atomic Time (TAI) is the time reference coordinate on the basis of the readings of atomic clocks, \n"
  "#  * operated in accordance with the definition of the second, the unit of time of the International System of Units. \n"
  "#  * TAI is a continuous time scale. UTC has discontinuities, as it is occasionally adjusted by leap seconds. \n"
  "#  * As of 1 January, 2022, TimestampIts is 5 seconds ahead of UTC, because since the ITS epoch on 1 January 2004 00:00:00.000 UTC, \n"
  "#  * further 5 leap seconds have been inserted in UTC.\n"
  "#  * \n"
  "#  * EXAMPLE: The value for TimestampIts for 1 January 2007 00:00:00.000 UTC is `94 694 401 000` milliseconds,\n"
  "#  * which includes one leap second insertion since the ITS epoch.\n"
  "#  * @unit: 0,001 s\n"
  "#  * @category: Basic information\n"
  "#  * @revision: Description revised in in V2.1.1\n"
  "#  */\n"
  "# TimestampIts ::= INTEGER (0..4398046511103)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint64 value\n"
  "uint64 MIN = 0\n"
  "uint64 MAX = 4398046511103\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__TimestampIts__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__TimestampIts__TYPE_NAME, 38, 38},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3150, 3150},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__TimestampIts__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__TimestampIts__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
