// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/AccelerationValue.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/acceleration_value__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__AccelerationValue__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x9b, 0x7c, 0x52, 0x8c, 0xb9, 0x53, 0x7d, 0xc1,
      0x8b, 0x21, 0xe4, 0x09, 0x72, 0xef, 0x8f, 0x80,
      0x65, 0xce, 0xfa, 0x83, 0xf9, 0x4b, 0x29, 0x23,
      0x80, 0x1b, 0x9f, 0x74, 0x5b, 0xc9, 0xf6, 0x98,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__AccelerationValue__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/AccelerationValue";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__AccelerationValue__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__AccelerationValue__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__AccelerationValue__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__AccelerationValue__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__AccelerationValue__TYPE_NAME, 43, 43},
      {etsi_its_denm_ts_msgs__msg__AccelerationValue__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /** \n"
  "#  * This DE represents the value of an acceleration component in a defined coordinate system.\n"
  "#  *\n"
  "#  * The value shall be set to:\n"
  "#  * - `-160` for acceleration values equal to or less than -16 m/s^2,\n"
  "#  * - `n` (`n > -160` and `n <= 0`) to indicate negative acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,\n"
  "#  * - `n` (`n > 0` and `n < 160`) to indicate positive acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,\n"
  "#  * - `160` for acceleration values greater than 15,9 m/s^2,\n"
  "#  * - `161` when the data is unavailable.\n"
  "#  *\n"
  "#  * @note: the formula for values > -160 and <160 results in rounding up to the next value. Zero acceleration is indicated using n=0.\n"
  "#  * @unit 0,1 m/s^2\n"
  "#  * @category: Kinematic information\n"
  "#  * @revision: Created in V2.1.1\n"
  "# */\n"
  "# AccelerationValue ::= INTEGER {\n"
  "#     negativeOutOfRange (-160),\n"
  "#     positiveOutOfRange (160),\n"
  "#     unavailable        (161)  \n"
  "# } (-160 .. 161)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "int16 value\n"
  "int16 MIN = -160\n"
  "int16 MAX = 161\n"
  "int16 NEGATIVE_OUT_OF_RANGE = -160\n"
  "int16 POSITIVE_OUT_OF_RANGE = 160\n"
  "int16 UNAVAILABLE = 161\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__AccelerationValue__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__AccelerationValue__TYPE_NAME, 43, 43},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3013, 3013},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__AccelerationValue__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__AccelerationValue__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
