// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/AngularSpeedConfidence.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/angular_speed_confidence__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__AngularSpeedConfidence__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xe2, 0x25, 0x77, 0xdc, 0x11, 0x4c, 0x95, 0x7f,
      0x68, 0x81, 0x34, 0x4f, 0x6f, 0x08, 0xd5, 0x79,
      0xfc, 0xb9, 0x3b, 0xef, 0xdb, 0x10, 0x88, 0x2b,
      0x06, 0x2c, 0xbd, 0x8b, 0x88, 0x74, 0x0c, 0x03,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__AngularSpeedConfidence__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/AngularSpeedConfidence";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__AngularSpeedConfidence__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__AngularSpeedConfidence__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__AngularSpeedConfidence__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__AngularSpeedConfidence__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__AngularSpeedConfidence__TYPE_NAME, 48, 48},
      {etsi_its_denm_ts_msgs__msg__AngularSpeedConfidence__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /** \n"
  "#  * This DE indicates the angular speed confidence value which represents the estimated absolute accuracy of an angular speed value with a default confidence level of 95 %.\n"
  "#  * If required, the confidence level can be defined by the corresponding standards applying this DE.\n"
  "#  * For correlation computation, maximum interval levels can be assumed.\n"
  "#  *\n"
  "#  * The value shall be set to:\n"
  "#  * - 0 - `degSec-01`   - if the accuracy is equal to or less than 1 degree/second,\n"
  "#  * - 1 - `degSec-02`   - if the accuracy is equal to or less than 2 degrees/second and greater than 1 degree/second,\n"
  "#  * - 2 - `degSec-05`   - if the accuracy is equal to or less than 5 degrees/second and greater than 2 degrees/second,\n"
  "#  * - 3 - `degSec-10`   - if the accuracy is equal to or less than 10 degrees/second and greater than 5 degrees/second,\n"
  "#  * - 4 - `degSec-20`   - if the accuracy is equal to or less than 20 degrees/second and greater than 10 degrees/second,\n"
  "#  * - 5 - `degSec-50`   - if the accuracy is equal to or less than 50 degrees/second and greater than 20 degrees/second,\n"
  "#  * - 6 - `outOfRange`  - if the accuracy is out of range, i.e. greater than 50 degrees/second,\n"
  "#  * - 7 - `unavailable` - if the accuracy information is unavailable.\n"
  "#  * \n"
  "#  * @category: Kinematic information\n"
  "#  * @revision: Created in V2.1.1\n"
  "# */\n"
  "# AngularSpeedConfidence ::= ENUMERATED {\n"
  "#     degSec-01   (0), \n"
  "#     degSec-02   (1),  \n"
  "#     degSec-05   (2), \n"
  "#     degSec-10   (3), \n"
  "#     degSec-20   (4),  \n"
  "#     degSec-50   (5), \n"
  "#     outOfRange  (6),   \n"
  "#     unavailable (7)   \n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 DEG_SEC_01 = 0\n"
  "uint8 DEG_SEC_02 = 1\n"
  "uint8 DEG_SEC_05 = 2\n"
  "uint8 DEG_SEC_10 = 3\n"
  "uint8 DEG_SEC_20 = 4\n"
  "uint8 DEG_SEC_50 = 5\n"
  "uint8 OUT_OF_RANGE = 6\n"
  "uint8 UNAVAILABLE = 7\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__AngularSpeedConfidence__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__AngularSpeedConfidence__TYPE_NAME, 48, 48},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3647, 3647},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__AngularSpeedConfidence__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__AngularSpeedConfidence__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
