// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/CorrelationCellValue.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/correlation_cell_value__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__CorrelationCellValue__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x7f, 0xf3, 0x40, 0xc7, 0xcf, 0x6b, 0xea, 0x38,
      0x1d, 0x7a, 0xcc, 0x6b, 0x53, 0xbb, 0x98, 0xcc,
      0xd6, 0xfa, 0x5a, 0x73, 0xbd, 0xcb, 0x71, 0x8d,
      0x3a, 0xbe, 0x3a, 0x9d, 0x5c, 0x69, 0x65, 0x79,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__CorrelationCellValue__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/CorrelationCellValue";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__CorrelationCellValue__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__CorrelationCellValue__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__CorrelationCellValue__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__CorrelationCellValue__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__CorrelationCellValue__TYPE_NAME, 46, 46},
      {etsi_its_denm_ts_msgs__msg__CorrelationCellValue__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /** \n"
  "#  * This DE represents the Bravais-Pearson correlation value for each cell of a lower triangular correlation matrix.\n"
  "#  *\n"
  "#  * The value shall be set to: \n"
  "#  * - `-100` in case of full negative correlation,\n"
  "#  * - `n` (`n > -100` and `n < 0`) if the correlation is negative and equal to n x 100,\n"
  "#  * - `0` in case of no correlation,\n"
  "#  * - `n` (`n > 0` and `n < 100`) if the correlation is positive and equal to n x 100,\n"
  "#  * - `100` in case of full positive correlation,\n"
  "#  * - `101` in case the correlation information is unavailable. \n"
  "#  *\n"
  "#  * @unit: the value is scaled by 100\n"
  "#  * @category: Basic information\n"
  "#  * @revision: Created in V2.1.1\n"
  "# */\n"
  "# CorrelationCellValue ::= INTEGER {\n"
  "#     full-negative-correlation    (-100),     \n"
  "#     no-correlation               (0),       \n"
  "#     full-positive-correlation    (100),\n"
  "#     unavailable (101)  \n"
  "# } (-100..101)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "int8 value\n"
  "int8 MIN = -100\n"
  "int8 MAX = 101\n"
  "int8 FULL_NEGATIVE_CORRELATION = -100\n"
  "int8 NO_CORRELATION = 0\n"
  "int8 FULL_POSITIVE_CORRELATION = 100\n"
  "int8 UNAVAILABLE = 101\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__CorrelationCellValue__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__CorrelationCellValue__TYPE_NAME, 46, 46},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2930, 2930},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__CorrelationCellValue__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__CorrelationCellValue__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
