// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/EventPoint.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/event_point.h"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__EVENT_POINT__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__EVENT_POINT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'event_position'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_reference_position__struct.h"
// Member 'event_delta_time'
#include "etsi_its_denm_ts_msgs/msg/detail/path_delta_time__struct.h"
// Member 'information_quality'
#include "etsi_its_denm_ts_msgs/msg/detail/information_quality__struct.h"

/// Struct defined in msg/EventPoint in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__EventPoint
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF provides information related to an event at a defined position.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field eventPosition: offset position of a detected event point to a defined position.
  ///  *
  ///  * @field eventDeltaTime: optional time travelled by the detecting ITS-S since the previous detected event point.
  ///  *
  ///  * @field informationQuality: Information quality of the detection for this event point.
  ///  *
  ///  * @category: GeoReference information, Traffic information
  ///  * @revision: generalized the semantics in V2.1.1
  ///  */
  /// EventPoint ::= SEQUENCE {
  ///     eventPosition         DeltaReferencePosition,
  ///     eventDeltaTime        PathDeltaTime OPTIONAL,
  ///     informationQuality    InformationQuality
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_ts_msgs__msg__DeltaReferencePosition event_position;
  etsi_its_denm_ts_msgs__msg__PathDeltaTime event_delta_time;
  bool event_delta_time_is_present;
  etsi_its_denm_ts_msgs__msg__InformationQuality information_quality;
} etsi_its_denm_ts_msgs__msg__EventPoint;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__EventPoint.
typedef struct etsi_its_denm_ts_msgs__msg__EventPoint__Sequence
{
  etsi_its_denm_ts_msgs__msg__EventPoint * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__EventPoint__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__EVENT_POINT__STRUCT_H_
