// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/PathDeltaTimeChoice.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/path_delta_time_choice.hpp"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_DELTA_TIME_CHOICE__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_DELTA_TIME_CHOICE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'delta_time_high_precision'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_time_tenth_of_second__struct.hpp"
// Member 'delta_time_big_range'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_time_ten_seconds__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__PathDeltaTimeChoice __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__PathDeltaTimeChoice __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PathDeltaTimeChoice_
{
  using Type = PathDeltaTimeChoice_<ContainerAllocator>;

  explicit PathDeltaTimeChoice_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : delta_time_high_precision(_init),
    delta_time_big_range(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  explicit PathDeltaTimeChoice_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : delta_time_high_precision(_alloc, _init),
    delta_time_big_range(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  // field types and members
  using _choice_type =
    uint8_t;
  _choice_type choice;
  using _delta_time_high_precision_type =
    etsi_its_denm_ts_msgs::msg::DeltaTimeTenthOfSecond_<ContainerAllocator>;
  _delta_time_high_precision_type delta_time_high_precision;
  using _delta_time_big_range_type =
    etsi_its_denm_ts_msgs::msg::DeltaTimeTenSeconds_<ContainerAllocator>;
  _delta_time_big_range_type delta_time_big_range;

  // setters for named parameter idiom
  Type & set__choice(
    const uint8_t & _arg)
  {
    this->choice = _arg;
    return *this;
  }
  Type & set__delta_time_high_precision(
    const etsi_its_denm_ts_msgs::msg::DeltaTimeTenthOfSecond_<ContainerAllocator> & _arg)
  {
    this->delta_time_high_precision = _arg;
    return *this;
  }
  Type & set__delta_time_big_range(
    const etsi_its_denm_ts_msgs::msg::DeltaTimeTenSeconds_<ContainerAllocator> & _arg)
  {
    this->delta_time_big_range = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t CHOICE_DELTA_TIME_HIGH_PRECISION =
    0u;
  static constexpr uint8_t CHOICE_DELTA_TIME_BIG_RANGE =
    1u;

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__PathDeltaTimeChoice
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__PathDeltaTimeChoice
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PathDeltaTimeChoice_ & other) const
  {
    if (this->choice != other.choice) {
      return false;
    }
    if (this->delta_time_high_precision != other.delta_time_high_precision) {
      return false;
    }
    if (this->delta_time_big_range != other.delta_time_big_range) {
      return false;
    }
    return true;
  }
  bool operator!=(const PathDeltaTimeChoice_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PathDeltaTimeChoice_

// alias to use template instance with default allocator
using PathDeltaTimeChoice =
  etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathDeltaTimeChoice_<ContainerAllocator>::CHOICE_DELTA_TIME_HIGH_PRECISION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathDeltaTimeChoice_<ContainerAllocator>::CHOICE_DELTA_TIME_BIG_RANGE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_DELTA_TIME_CHOICE__STRUCT_HPP_
