// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_denm_ts_msgs:msg/PreCrashContainer.idl
// generated code does not contain a copyright notice
#include "etsi_its_denm_ts_msgs/msg/detail/pre_crash_container__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `perceived_pre_crash_object`
#include "etsi_its_denm_ts_msgs/msg/detail/perceived_object__functions.h"
// Member `object_station_id`
#include "etsi_its_denm_ts_msgs/msg/detail/station_id__functions.h"
// Member `time_to_collision`
#include "etsi_its_denm_ts_msgs/msg/detail/delta_time_milli_second_positive__functions.h"
// Member `impact_section`
#include "etsi_its_denm_ts_msgs/msg/detail/object_face__functions.h"
// Member `estimated_braking_distance`
#include "etsi_its_denm_ts_msgs/msg/detail/standard_length12b__functions.h"

bool
etsi_its_denm_ts_msgs__msg__PreCrashContainer__init(etsi_its_denm_ts_msgs__msg__PreCrashContainer * msg)
{
  if (!msg) {
    return false;
  }
  // perceived_pre_crash_object
  if (!etsi_its_denm_ts_msgs__msg__PerceivedObject__init(&msg->perceived_pre_crash_object)) {
    etsi_its_denm_ts_msgs__msg__PreCrashContainer__fini(msg);
    return false;
  }
  // object_station_id
  if (!etsi_its_denm_ts_msgs__msg__StationId__init(&msg->object_station_id)) {
    etsi_its_denm_ts_msgs__msg__PreCrashContainer__fini(msg);
    return false;
  }
  // object_station_id_is_present
  // time_to_collision
  if (!etsi_its_denm_ts_msgs__msg__DeltaTimeMilliSecondPositive__init(&msg->time_to_collision)) {
    etsi_its_denm_ts_msgs__msg__PreCrashContainer__fini(msg);
    return false;
  }
  // time_to_collision_is_present
  // impact_section
  if (!etsi_its_denm_ts_msgs__msg__ObjectFace__init(&msg->impact_section)) {
    etsi_its_denm_ts_msgs__msg__PreCrashContainer__fini(msg);
    return false;
  }
  // impact_section_is_present
  // estimated_braking_distance
  if (!etsi_its_denm_ts_msgs__msg__StandardLength12b__init(&msg->estimated_braking_distance)) {
    etsi_its_denm_ts_msgs__msg__PreCrashContainer__fini(msg);
    return false;
  }
  // estimated_braking_distance_is_present
  return true;
}

void
etsi_its_denm_ts_msgs__msg__PreCrashContainer__fini(etsi_its_denm_ts_msgs__msg__PreCrashContainer * msg)
{
  if (!msg) {
    return;
  }
  // perceived_pre_crash_object
  etsi_its_denm_ts_msgs__msg__PerceivedObject__fini(&msg->perceived_pre_crash_object);
  // object_station_id
  etsi_its_denm_ts_msgs__msg__StationId__fini(&msg->object_station_id);
  // object_station_id_is_present
  // time_to_collision
  etsi_its_denm_ts_msgs__msg__DeltaTimeMilliSecondPositive__fini(&msg->time_to_collision);
  // time_to_collision_is_present
  // impact_section
  etsi_its_denm_ts_msgs__msg__ObjectFace__fini(&msg->impact_section);
  // impact_section_is_present
  // estimated_braking_distance
  etsi_its_denm_ts_msgs__msg__StandardLength12b__fini(&msg->estimated_braking_distance);
  // estimated_braking_distance_is_present
}

bool
etsi_its_denm_ts_msgs__msg__PreCrashContainer__are_equal(const etsi_its_denm_ts_msgs__msg__PreCrashContainer * lhs, const etsi_its_denm_ts_msgs__msg__PreCrashContainer * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // perceived_pre_crash_object
  if (!etsi_its_denm_ts_msgs__msg__PerceivedObject__are_equal(
      &(lhs->perceived_pre_crash_object), &(rhs->perceived_pre_crash_object)))
  {
    return false;
  }
  // object_station_id
  if (!etsi_its_denm_ts_msgs__msg__StationId__are_equal(
      &(lhs->object_station_id), &(rhs->object_station_id)))
  {
    return false;
  }
  // object_station_id_is_present
  if (lhs->object_station_id_is_present != rhs->object_station_id_is_present) {
    return false;
  }
  // time_to_collision
  if (!etsi_its_denm_ts_msgs__msg__DeltaTimeMilliSecondPositive__are_equal(
      &(lhs->time_to_collision), &(rhs->time_to_collision)))
  {
    return false;
  }
  // time_to_collision_is_present
  if (lhs->time_to_collision_is_present != rhs->time_to_collision_is_present) {
    return false;
  }
  // impact_section
  if (!etsi_its_denm_ts_msgs__msg__ObjectFace__are_equal(
      &(lhs->impact_section), &(rhs->impact_section)))
  {
    return false;
  }
  // impact_section_is_present
  if (lhs->impact_section_is_present != rhs->impact_section_is_present) {
    return false;
  }
  // estimated_braking_distance
  if (!etsi_its_denm_ts_msgs__msg__StandardLength12b__are_equal(
      &(lhs->estimated_braking_distance), &(rhs->estimated_braking_distance)))
  {
    return false;
  }
  // estimated_braking_distance_is_present
  if (lhs->estimated_braking_distance_is_present != rhs->estimated_braking_distance_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__PreCrashContainer__copy(
  const etsi_its_denm_ts_msgs__msg__PreCrashContainer * input,
  etsi_its_denm_ts_msgs__msg__PreCrashContainer * output)
{
  if (!input || !output) {
    return false;
  }
  // perceived_pre_crash_object
  if (!etsi_its_denm_ts_msgs__msg__PerceivedObject__copy(
      &(input->perceived_pre_crash_object), &(output->perceived_pre_crash_object)))
  {
    return false;
  }
  // object_station_id
  if (!etsi_its_denm_ts_msgs__msg__StationId__copy(
      &(input->object_station_id), &(output->object_station_id)))
  {
    return false;
  }
  // object_station_id_is_present
  output->object_station_id_is_present = input->object_station_id_is_present;
  // time_to_collision
  if (!etsi_its_denm_ts_msgs__msg__DeltaTimeMilliSecondPositive__copy(
      &(input->time_to_collision), &(output->time_to_collision)))
  {
    return false;
  }
  // time_to_collision_is_present
  output->time_to_collision_is_present = input->time_to_collision_is_present;
  // impact_section
  if (!etsi_its_denm_ts_msgs__msg__ObjectFace__copy(
      &(input->impact_section), &(output->impact_section)))
  {
    return false;
  }
  // impact_section_is_present
  output->impact_section_is_present = input->impact_section_is_present;
  // estimated_braking_distance
  if (!etsi_its_denm_ts_msgs__msg__StandardLength12b__copy(
      &(input->estimated_braking_distance), &(output->estimated_braking_distance)))
  {
    return false;
  }
  // estimated_braking_distance_is_present
  output->estimated_braking_distance_is_present = input->estimated_braking_distance_is_present;
  return true;
}

etsi_its_denm_ts_msgs__msg__PreCrashContainer *
etsi_its_denm_ts_msgs__msg__PreCrashContainer__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__PreCrashContainer * msg = (etsi_its_denm_ts_msgs__msg__PreCrashContainer *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__PreCrashContainer), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_denm_ts_msgs__msg__PreCrashContainer));
  bool success = etsi_its_denm_ts_msgs__msg__PreCrashContainer__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_denm_ts_msgs__msg__PreCrashContainer__destroy(etsi_its_denm_ts_msgs__msg__PreCrashContainer * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_denm_ts_msgs__msg__PreCrashContainer__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence__init(etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__PreCrashContainer * data = NULL;

  if (size) {
    data = (etsi_its_denm_ts_msgs__msg__PreCrashContainer *)allocator.zero_allocate(size, sizeof(etsi_its_denm_ts_msgs__msg__PreCrashContainer), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_denm_ts_msgs__msg__PreCrashContainer__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_denm_ts_msgs__msg__PreCrashContainer__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence__fini(etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_denm_ts_msgs__msg__PreCrashContainer__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence *
etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence * array = (etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence__destroy(etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence__are_equal(const etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence * lhs, const etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__PreCrashContainer__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence__copy(
  const etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence * input,
  etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_denm_ts_msgs__msg__PreCrashContainer);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_denm_ts_msgs__msg__PreCrashContainer * data =
      (etsi_its_denm_ts_msgs__msg__PreCrashContainer *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_denm_ts_msgs__msg__PreCrashContainer__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_denm_ts_msgs__msg__PreCrashContainer__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__PreCrashContainer__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
