// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/RescueAndRecoveryWorkInProgressSubCauseCode.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/rescue_and_recovery_work_in_progress_sub_cause_code__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x3c, 0x32, 0x30, 0x51, 0xc4, 0x40, 0xde, 0xf5,
      0xf7, 0x56, 0xee, 0x13, 0xa8, 0xf6, 0x4e, 0xde,
      0x8d, 0x09, 0x47, 0x6f, 0x2b, 0xbb, 0x88, 0x01,
      0x20, 0x40, 0x3b, 0x75, 0x6e, 0x60, 0xa4, 0x3b,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/RescueAndRecoveryWorkInProgressSubCauseCode";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__TYPE_NAME, 69, 69},
      {etsi_its_denm_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents the value of the sub cause codes of the @ref CauseCode `rescueAndRecoveryWorkInProgress` \n"
  "#  * \n"
  "#  * The value shall be set to:\n"
  "#  * - 0 `unavailable`              - in case further detailed information on rescue and recovery work is unavailable,\n"
  "#  * - 1 `emergencyVehicles`        - in case rescue and/or safeguarding work is ongoing by emergency vehicles, i.e. by vehicles that have the absolute right of way,\n"
  "#  * - 2 `rescueHelicopterLanding`  - in case rescue helicopter is landing,\n"
  "#  * - 3 `policeActivityOngoing`    - in case police activity is ongoing (only to be used if a more specific sub cause than (1) is needed),\n"
  "#  * - 4 `medicalEmergencyOngoing`  - in case medical emergency recovery is ongoing (only to be used if a more specific sub cause than (1) is needed),\n"
  "#  * - 5 `childAbductionInProgress` - in case a child kidnapping alarm is activated and rescue work is ongoing (only to be used if a more specific sub cause than (1) is needed),\n"
  "#  * - 6 `prioritizedVehicle`       - in case rescue and/or safeguarding work is ongoing by prioritized vehicles, i.e. by vehicles that have priority but not the absolute right of way,\n"
  "#  * - 7 `rescueAndRecoveryVehicle` - in case technical rescue work is ongoing by rescue and recovery vehicles.\n"
  "#  * - 8-255: reserved for future usage.\n"
  "# \n"
  "#  *\n"
  "#  * @category: Traffic information\n"
  "#  * @revision: V1.3.1, named values 6 and 7 added in V2.2.1\n"
  "#  */\n"
  "# RescueAndRecoveryWorkInProgressSubCauseCode ::= INTEGER {\n"
  "#    unavailable              (0), \n"
  "#    emergencyVehicles        (1), \n"
  "#    rescueHelicopterLanding  (2), \n"
  "#    policeActivityOngoing    (3), \n"
  "#    medicalEmergencyOngoing  (4), \n"
  "#    childAbductionInProgress (5),\n"
  "#    prioritizedVehicle       (6),\n"
  "#    rescueAndRecoveryVehicle (7)\n"
  "# } (0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 EMERGENCY_VEHICLES = 1\n"
  "uint8 RESCUE_HELICOPTER_LANDING = 2\n"
  "uint8 POLICE_ACTIVITY_ONGOING = 3\n"
  "uint8 MEDICAL_EMERGENCY_ONGOING = 4\n"
  "uint8 CHILD_ABDUCTION_IN_PROGRESS = 5\n"
  "uint8 PRIORITIZED_VEHICLE = 6\n"
  "uint8 RESCUE_AND_RECOVERY_VEHICLE = 7\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__TYPE_NAME, 69, 69},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3985, 3985},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
