// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_denm_ts_msgs:msg/RoadSectionDefinition.idl
// generated code does not contain a copyright notice
#include "etsi_its_denm_ts_msgs/msg/detail/road_section_definition__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `starting_point_section`
// Member `ending_point_section`
#include "etsi_its_denm_ts_msgs/msg/detail/geo_position__functions.h"
// Member `length_of_section`
#include "etsi_its_denm_ts_msgs/msg/detail/standard_length2_b__functions.h"
// Member `connected_paths`
// Member `included_paths`
#include "etsi_its_denm_ts_msgs/msg/detail/path_references__functions.h"

bool
etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__init(etsi_its_denm_ts_msgs__msg__RoadSectionDefinition * msg)
{
  if (!msg) {
    return false;
  }
  // starting_point_section
  if (!etsi_its_denm_ts_msgs__msg__GeoPosition__init(&msg->starting_point_section)) {
    etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__fini(msg);
    return false;
  }
  // length_of_section
  if (!etsi_its_denm_ts_msgs__msg__StandardLength2B__init(&msg->length_of_section)) {
    etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__fini(msg);
    return false;
  }
  // length_of_section_is_present
  // ending_point_section
  if (!etsi_its_denm_ts_msgs__msg__GeoPosition__init(&msg->ending_point_section)) {
    etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__fini(msg);
    return false;
  }
  // ending_point_section_is_present
  // connected_paths
  if (!etsi_its_denm_ts_msgs__msg__PathReferences__init(&msg->connected_paths)) {
    etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__fini(msg);
    return false;
  }
  // included_paths
  if (!etsi_its_denm_ts_msgs__msg__PathReferences__init(&msg->included_paths)) {
    etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__fini(msg);
    return false;
  }
  // is_event_zone_included
  // is_event_zone_connected
  return true;
}

void
etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__fini(etsi_its_denm_ts_msgs__msg__RoadSectionDefinition * msg)
{
  if (!msg) {
    return;
  }
  // starting_point_section
  etsi_its_denm_ts_msgs__msg__GeoPosition__fini(&msg->starting_point_section);
  // length_of_section
  etsi_its_denm_ts_msgs__msg__StandardLength2B__fini(&msg->length_of_section);
  // length_of_section_is_present
  // ending_point_section
  etsi_its_denm_ts_msgs__msg__GeoPosition__fini(&msg->ending_point_section);
  // ending_point_section_is_present
  // connected_paths
  etsi_its_denm_ts_msgs__msg__PathReferences__fini(&msg->connected_paths);
  // included_paths
  etsi_its_denm_ts_msgs__msg__PathReferences__fini(&msg->included_paths);
  // is_event_zone_included
  // is_event_zone_connected
}

bool
etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__are_equal(const etsi_its_denm_ts_msgs__msg__RoadSectionDefinition * lhs, const etsi_its_denm_ts_msgs__msg__RoadSectionDefinition * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // starting_point_section
  if (!etsi_its_denm_ts_msgs__msg__GeoPosition__are_equal(
      &(lhs->starting_point_section), &(rhs->starting_point_section)))
  {
    return false;
  }
  // length_of_section
  if (!etsi_its_denm_ts_msgs__msg__StandardLength2B__are_equal(
      &(lhs->length_of_section), &(rhs->length_of_section)))
  {
    return false;
  }
  // length_of_section_is_present
  if (lhs->length_of_section_is_present != rhs->length_of_section_is_present) {
    return false;
  }
  // ending_point_section
  if (!etsi_its_denm_ts_msgs__msg__GeoPosition__are_equal(
      &(lhs->ending_point_section), &(rhs->ending_point_section)))
  {
    return false;
  }
  // ending_point_section_is_present
  if (lhs->ending_point_section_is_present != rhs->ending_point_section_is_present) {
    return false;
  }
  // connected_paths
  if (!etsi_its_denm_ts_msgs__msg__PathReferences__are_equal(
      &(lhs->connected_paths), &(rhs->connected_paths)))
  {
    return false;
  }
  // included_paths
  if (!etsi_its_denm_ts_msgs__msg__PathReferences__are_equal(
      &(lhs->included_paths), &(rhs->included_paths)))
  {
    return false;
  }
  // is_event_zone_included
  if (lhs->is_event_zone_included != rhs->is_event_zone_included) {
    return false;
  }
  // is_event_zone_connected
  if (lhs->is_event_zone_connected != rhs->is_event_zone_connected) {
    return false;
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__copy(
  const etsi_its_denm_ts_msgs__msg__RoadSectionDefinition * input,
  etsi_its_denm_ts_msgs__msg__RoadSectionDefinition * output)
{
  if (!input || !output) {
    return false;
  }
  // starting_point_section
  if (!etsi_its_denm_ts_msgs__msg__GeoPosition__copy(
      &(input->starting_point_section), &(output->starting_point_section)))
  {
    return false;
  }
  // length_of_section
  if (!etsi_its_denm_ts_msgs__msg__StandardLength2B__copy(
      &(input->length_of_section), &(output->length_of_section)))
  {
    return false;
  }
  // length_of_section_is_present
  output->length_of_section_is_present = input->length_of_section_is_present;
  // ending_point_section
  if (!etsi_its_denm_ts_msgs__msg__GeoPosition__copy(
      &(input->ending_point_section), &(output->ending_point_section)))
  {
    return false;
  }
  // ending_point_section_is_present
  output->ending_point_section_is_present = input->ending_point_section_is_present;
  // connected_paths
  if (!etsi_its_denm_ts_msgs__msg__PathReferences__copy(
      &(input->connected_paths), &(output->connected_paths)))
  {
    return false;
  }
  // included_paths
  if (!etsi_its_denm_ts_msgs__msg__PathReferences__copy(
      &(input->included_paths), &(output->included_paths)))
  {
    return false;
  }
  // is_event_zone_included
  output->is_event_zone_included = input->is_event_zone_included;
  // is_event_zone_connected
  output->is_event_zone_connected = input->is_event_zone_connected;
  return true;
}

etsi_its_denm_ts_msgs__msg__RoadSectionDefinition *
etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__RoadSectionDefinition * msg = (etsi_its_denm_ts_msgs__msg__RoadSectionDefinition *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__RoadSectionDefinition), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_denm_ts_msgs__msg__RoadSectionDefinition));
  bool success = etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__destroy(etsi_its_denm_ts_msgs__msg__RoadSectionDefinition * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence__init(etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__RoadSectionDefinition * data = NULL;

  if (size) {
    data = (etsi_its_denm_ts_msgs__msg__RoadSectionDefinition *)allocator.zero_allocate(size, sizeof(etsi_its_denm_ts_msgs__msg__RoadSectionDefinition), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence__fini(etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence *
etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence * array = (etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence__destroy(etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence__are_equal(const etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence * lhs, const etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence__copy(
  const etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence * input,
  etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_denm_ts_msgs__msg__RoadSectionDefinition);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_denm_ts_msgs__msg__RoadSectionDefinition * data =
      (etsi_its_denm_ts_msgs__msg__RoadSectionDefinition *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
