// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/Temperature.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/temperature.h"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__TEMPERATURE__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__TEMPERATURE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_denm_ts_msgs__msg__Temperature__MIN = -60
};

/// Constant 'MAX'.
enum
{
  etsi_its_denm_ts_msgs__msg__Temperature__MAX = 67
};

/// Constant 'EQUAL_OR_SMALLER_THAN_MINUS60_DEG'.
enum
{
  etsi_its_denm_ts_msgs__msg__Temperature__EQUAL_OR_SMALLER_THAN_MINUS60_DEG = -60
};

/// Constant 'EQUAL_OR_GREATER_THAN67_DEG'.
enum
{
  etsi_its_denm_ts_msgs__msg__Temperature__EQUAL_OR_GREATER_THAN67_DEG = 67
};

/// Struct defined in msg/Temperature in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__Temperature
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates a temperature value.
  ///
  ///  * The value shall be set to:
  ///  * - `-60` for temperature equal to or less than -60 degrees C,
  ///  * - `n` (`n > -60` and `n < 67`) for the actual temperature n in degrees C,
  ///  * - `67` for temperature equal to or greater than 67 degrees C.
  ///  *
  ///  * @unit: degrees Celsius
  ///  * @category: Basic information
  ///  * @revision: Editorial update in V2.1.1
  ///  */
  /// Temperature ::= INTEGER {
  ///     equalOrSmallerThanMinus60Deg (-60),
  ///     equalOrGreaterThan67Deg(67)} (-60..67)
  /// ------------------------------------------------------------------------------
  int8_t value;
} etsi_its_denm_ts_msgs__msg__Temperature;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__Temperature.
typedef struct etsi_its_denm_ts_msgs__msg__Temperature__Sequence
{
  etsi_its_denm_ts_msgs__msg__Temperature * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__Temperature__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__TEMPERATURE__STRUCT_H_
