// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/VehicleBreakdownSubCauseCode.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/vehicle_breakdown_sub_cause_code__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__VehicleBreakdownSubCauseCode__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x42, 0x56, 0xdf, 0xcb, 0x8b, 0x75, 0xde, 0x16,
      0xd1, 0xb3, 0xf3, 0xd5, 0x11, 0x6d, 0x91, 0x53,
      0x4b, 0x36, 0xd5, 0x69, 0x8a, 0x85, 0xc3, 0xeb,
      0x6b, 0x6e, 0xf5, 0xaa, 0xf2, 0x91, 0xec, 0xcb,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__VehicleBreakdownSubCauseCode__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/VehicleBreakdownSubCauseCode";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__VehicleBreakdownSubCauseCode__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__VehicleBreakdownSubCauseCode__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__VehicleBreakdownSubCauseCode__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__VehicleBreakdownSubCauseCode__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__VehicleBreakdownSubCauseCode__TYPE_NAME, 54, 54},
      {etsi_its_denm_ts_msgs__msg__VehicleBreakdownSubCauseCode__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents the value of the sub cause codes of the @ref CauseCode `vehicleBreakdown`. \n"
  "#  * \n"
  "#  * The value shall be set to:\n"
  "#  * - 0 `unavailable`         - in case further detailed information on cause of vehicle break down is unavailable,\n"
  "#  * - 1 `lackOfFuel`          - in case vehicle break down is due to lack of fuel,\n"
  "#  * - 2 `lackOfBatteryPower`  - in case vehicle break down is caused by lack of battery power,\n"
  "#  * - 3 `engineProblem`       - in case vehicle break down is caused by an engine problem,\n"
  "#  * - 4 `transmissionProblem` - in case vehicle break down is caused by transmission problem,\n"
  "#  * - 5 `engineCoolingProblem`- in case vehicle break down is caused by an engine cooling problem,\n"
  "#  * - 6 `brakingSystemProblem`- in case vehicle break down is caused by a braking system problem,\n"
  "#  * - 7 `steeringProblem`     - in case vehicle break down is caused by a steering problem,\n"
  "#  * - 8 `tyrePuncture`        - in case vehicle break down is caused by tyre puncture,\n"
  "#  * - 9 `tyrePressureProblem` - in case low tyre pressure in detected,\n"
  "#  * - 10 `vehicleOnFire`      - in case the vehicle is on fire.\n"
  "#  * - 11-255                  - are reserved for future usage.\n"
  "#  *\n"
  "#  * @category: Traffic information\n"
  "# \n"
  "#  */\n"
  "# VehicleBreakdownSubCauseCode ::= INTEGER {\n"
  "#     unavailable          (0), \n"
  "#     lackOfFuel           (1), \n"
  "#     lackOfBatteryPower   (2), \n"
  "#     engineProblem        (3), \n"
  "#     transmissionProblem  (4), \n"
  "#     engineCoolingProblem (5), \n"
  "#     brakingSystemProblem (6), \n"
  "#     steeringProblem      (7), \n"
  "#     tyrePuncture         (8), \n"
  "#     tyrePressureProblem  (9), \n"
  "#     vehicleOnFire        (10)\n"
  "# } (0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 LACK_OF_FUEL = 1\n"
  "uint8 LACK_OF_BATTERY_POWER = 2\n"
  "uint8 ENGINE_PROBLEM = 3\n"
  "uint8 TRANSMISSION_PROBLEM = 4\n"
  "uint8 ENGINE_COOLING_PROBLEM = 5\n"
  "uint8 BRAKING_SYSTEM_PROBLEM = 6\n"
  "uint8 STEERING_PROBLEM = 7\n"
  "uint8 TYRE_PUNCTURE = 8\n"
  "uint8 TYRE_PRESSURE_PROBLEM = 9\n"
  "uint8 VEHICLE_ON_FIRE = 10\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__VehicleBreakdownSubCauseCode__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__VehicleBreakdownSubCauseCode__TYPE_NAME, 54, 54},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3916, 3916},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__VehicleBreakdownSubCauseCode__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__VehicleBreakdownSubCauseCode__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
